// ***********************************************************
// Project:     8  - 
// Author:	 
// http://startcd.narod.ru/
// Module description: v2.2
//  RC  4 Meg
// WinAVR - 20060421
// ***********************************************************
#include <avr/io.h>
#include <avr/interrupt.h>


#define BIT	_BV
#define _setpin	  1
#define	_pluspin  2	
#define	_minuspin 3
#define	PINKEY	PINB
#define SET		(key==1)		
#define PLUS	(key==2)
#define MINUS	(key==3)
#define PORTLCD PORTB
#define DDRLCD	DDRB
#define sk	4
#define di	5
#define PORTCULER	PORTD
#define DDRCULER	DDRD
#define	culer_p	PD0
#define	culer_1	PD1
#define	culer_2	PD2
#define	culer_3	PD3
#define	culer_4	PD4


#define flag_view_1para		1 // view_state1_in_lcd 1,2  3,4 
#define flag_blank_param	2 // 1 -   
#define flag_num_out		3 //    lcd
#define flag_adc			4 //   U 0-;        
#define flag_n_result		5 //  
#define flag_satrt_end		7 //   CPU


#define view_state_eeprom		3	//unsigned char	1byte
#define	t_ofset_eeprom 			5 	//unsigned char	1byte
#define	u1grc_eeprom			7	//unsigned char	1byte
#define	parametr_eeprom			10 	//unsigned char	parametr[10] 10byte
#define	uprav_culer_eeprom		25 	//unsigned char	uprav_culer[5]={1,1,1,1,1};// 5byte
#define	raskrutka_culer_eeprom	35	//[5]
#define	u_measure_const_eeprom	45	//unsigned int	u_measure_const[4] 8byte

unsigned char lcd_buffer[10], bcd_num1, bcd_num2, bcd_num3, bcd_num4;
unsigned char time_in_regim, time_1sek=61, time_flag, time_lcd=2, time_blank, time_state_switch=4, time_start=15;
unsigned char	regim, key, anti_drebezg[3];
unsigned char view_state;//=0;
unsigned char ukaz_na_param;//=0;
unsigned char uprav_culer[5]/* 0- .; 1-; 2- .*/ , raskrutka_culer[5]/*0- off 1-on*/;
unsigned char	pin_culer[5]={BIT(culer_p),BIT(culer_1),BIT(culer_2),BIT(culer_3),BIT(culer_4)};//()  
unsigned char t_ofset;//=21;//   . 
unsigned char u1grc;//=8; //    
#define shag_u	25//     // ADC
unsigned char kanal;// 
signed char parametr[10];//={40,50,30,55,45,60,10,52,40,50}; //
signed int u_measure_const[8];//={500,500,500,500,400,400,400,400};//rezultat0,rezultat1,rezultat2,rezultat3,ofset0,ofset1,ofset2,ofset3
signed int trezult[4];// 

//**********************************************************************
SIGNAL(SIG_ADC){
u_measure_const[kanal]+=ADC;
}
//**********************************
SIGNAL(SIG_OVERFLOW0){
////61.0351Hz 0.016384sek
TCNT0=100;//0.01sek
}
//**********************************
void acd_init(void){
	/*Bit 7  ADEN: ADC Enable
	Bit 6  ADSC: ADC Start Conversion
	Bit 5  ADFR: ADC Free Running Select
	Bit 4  ADIF: ADC Interrupt Flag
	Bit 3  ADIE: ADC Interrupt Enable
	Bits 2:0  ADPS2:0: ADC Prescaler Select Bits*/
	ADCSRA=BIT(ADEN)|BIT(ADPS2)|BIT(ADPS0)|BIT(ADIE);
	//Internal 2.56V Voltage Reference with external capacitor at AREF pin
	#define ADMUX_SETTING	( BIT(REFS1)|BIT(REFS0) )
	ADMUX=ADMUX_SETTING;
}
//**********************************
void timer0_init(void){
////61.0351Hz 0.016384sek
	TCCR0=0b100;// clkI/O/256 (From prescaler)
	TIMSK|=BIT(TOIE0);
}
//**********************************
void port_init(void){
	PORTLCD=~(BIT(sk)|BIT(di));// .  di sk
	DDRLCD|=BIT(sk)|BIT(di);
	PORTCULER&=~(BIT(culer_p)|BIT(culer_1)|BIT(culer_2)|BIT(culer_3)|BIT(culer_4));
	DDRCULER|=BIT(culer_p)|BIT(culer_1)|BIT(culer_2)|BIT(culer_3)|BIT(culer_4);
}
// ***********************************************************
//   
unsigned char EEPROM_read(unsigned int uiAddress)
{
	/*     */
	while(EECR & (1<<EEWE));
	/*    */
	EEAR = uiAddress;
	/*       EERE */
	EECR |= (1<<EERE);
	/*      */
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
}
//*********************************************
void data_init(void){
unsigned char i, *a;

	view_state=EEPROM_read(view_state_eeprom);
	if (view_state>5) view_state=0;
	t_ofset=EEPROM_read(t_ofset_eeprom);
	u1grc=EEPROM_read(u1grc_eeprom);
	
	for(i=parametr_eeprom; i<parametr_eeprom+10; i++)
			parametr[i-parametr_eeprom]=EEPROM_read(i);
			
	for(i=uprav_culer_eeprom; i<uprav_culer_eeprom+5 ; i++)
			uprav_culer[i-uprav_culer_eeprom]=EEPROM_read(i);
	
	for(i=raskrutka_culer_eeprom; i<raskrutka_culer_eeprom+5 ; i++){
			raskrutka_culer[i-raskrutka_culer_eeprom]=EEPROM_read(i);
			if ( raskrutka_culer[i-raskrutka_culer_eeprom] ) 
				if ( uprav_culer[i-raskrutka_culer_eeprom] )  uprav_culer[i-raskrutka_culer_eeprom]=2;
			}
			
	a=(unsigned char *)&u_measure_const[4];		
	for(i=u_measure_const_eeprom; i<u_measure_const_eeprom+8; i++, a++)
			*a=EEPROM_read(i);
}
//**********************************

void adc_receive(unsigned char _kanal_, unsigned char pin){
unsigned char i;
	
	kanal=_kanal_;
	ADMUX=ADMUX_SETTING|pin;
	u_measure_const[_kanal_]=0;
	for(i=0; i<8; i++)
		{
		MCUCR = BIT(SE)|BIT(SM0);
		asm("sleep");
	}
	u_measure_const[_kanal_]/=8;
}

void measure_u(void){
unsigned char timsk_;
	timsk_=TIMSK;
	TIMSK=0;
	
	adc_receive(0,1);
	adc_receive(1,2);
	adc_receive(2,0);
	adc_receive(3,3);
	
	TIMSK=timsk_;
	MCUCR=0;
}
//**********************************
void receive_t(void){
unsigned char i;	// t=(Uizmerennoe-Uconst)/Una_1_gradus+T_dlia_Uconst

if ( time_flag&BIT(flag_adc)){

	measure_u();
	for(i=0; i<4; i++)
		{
		trezult[i]=( (u_measure_const[i]-u_measure_const[i+4])*10/u1grc )+t_ofset*10;
		}

	time_flag&=~BIT(flag_adc);
	}
}

//**************************************
void skan_key(void)
{	//    0.01sek
	 unsigned char key_lokal=17;
	
	 key=key_lokal;
	 if 		(bit_is_clear(PINKEY,_setpin))		key_lokal=1;
	 else	 if (bit_is_clear(PINKEY,_pluspin))	key_lokal=2;
	 else	 if (bit_is_clear(PINKEY,_minuspin))	key_lokal=3;
	 else	 key_lokal=17;
	
	 if (key_lokal!=17)
	 {
	   anti_drebezg[0]++;//// 0- 1- 
	   if (anti_drebezg[0]==10)  //15
						key=key_lokal;
	   if (anti_drebezg[0]==anti_drebezg[2]){//
	   	   anti_drebezg[0]=0;
		   anti_drebezg[1]++;
		   if (anti_drebezg[1]==4) anti_drebezg[2]=15;//25
		   }	
	   time_in_regim=25;
	   time_flag&=~BIT(flag_blank_param);//  . display_direct()
	   time_flag|=BIT(flag_num_out);
	   time_blank=2;//..time_blank--
	 }
	 else
	 {
	   anti_drebezg[0]=0;//
	   anti_drebezg[1]=0;// -   
	   anti_drebezg[2]=60;//  *0.01sek=0.5
	 }
}
//**************************************/
void inc_dec_var(unsigned char *var, unsigned char limit){
		if (*var>limit) *var=limit;
		if (PLUS)	 if ((*var)<limit) (*var)++;
		if (MINUS) 	 if (*var) 		   (*var)--;
}
//**************************************/
void key_action(void){
unsigned char i, *a;
	if ( (key==17)&&(!regim) ) return;
	
	if (regim==0){
		if (SET) regim=20;
		else if (PLUS) { if ( time_flag & BIT(flag_satrt_end) ) regim=40; else regim=42;}
		else if (MINUS) regim=50;
		return;
		}
	
	if (regim==20){
		inc_dec_var(&view_state,5);// _|0|_
		if (SET) {
			EEPROM_write(view_state_eeprom,view_state);
			regim=30;
			ukaz_na_param=0;
			}
		return;
		}
		
	//begin**********  -  *********************
	if (regim==30){//      
		if (PLUS)  ukaz_na_param+=2;//if (ukaz_na_param<7)
		if (MINUS) if (ukaz_na_param>1)  ukaz_na_param-=2;
		if (ukaz_na_param>=10) regim=0;//key=1;//key=set
		if (SET)  	regim=31;
		return;
		}
	if (regim==31){//      // P|_ 00-00// low param
		inc_dec_var(&parametr[ukaz_na_param],99);
		if (SET) {
			ukaz_na_param++;
			regim=32;
			}
		return;
		}
	if (regim==32){//      // P|_ 00-00// hi param
		inc_dec_var(&parametr[ukaz_na_param],99);
		if (SET) {
			for(i=parametr_eeprom; i<parametr_eeprom+10; i++) EEPROM_write(i,parametr[i-parametr_eeprom]);
			ukaz_na_param++;
			regim=30;
			}
		return;
		}
	//end**********  -  *********************	
	
	//begin******** ********************************************
	if (regim==40){
		if (PLUS) regim=42;//   -  
		if (SET) {
			ukaz_na_param=0;
			regim=41;
			}
		return;
		}
	if (regim==41){
		inc_dec_var(&uprav_culer[ukaz_na_param],2);
		if (SET) {
			for(i=uprav_culer_eeprom; i<uprav_culer_eeprom+5; i++) EEPROM_write(i,uprav_culer[i-uprav_culer_eeprom]);
			ukaz_na_param++;
			if (ukaz_na_param>4) regim=0;
			}
		return;
		}
	if (regim==42){// 
		if (PLUS) regim=0;
		if (SET) {
			ukaz_na_param=1;//   
			regim=43;
			}
		return;
		}
	if (regim==43){
		inc_dec_var(&raskrutka_culer[ukaz_na_param],1);
		if (SET) {
			for(i=raskrutka_culer_eeprom; i<raskrutka_culer_eeprom+5; i++) EEPROM_write(i,raskrutka_culer[i-raskrutka_culer_eeprom]);
			ukaz_na_param++;
			if (ukaz_na_param>4) regim=0;
			}
		return;
		}
	//end********** ********************************************
	
	//begin******** ********************************************
	if (regim==50){
		inc_dec_var(&t_ofset,50);
		if (SET) {
			regim=55;//regim=51;//debug55
			EEPROM_write(t_ofset_eeprom,t_ofset);
			}
		return;
		}
	if (regim==55){
		if (PLUS) {
			a=(unsigned char *)&u_measure_const[0];
			for (i=u_measure_const_eeprom; i<u_measure_const_eeprom+8 ; i++, a++)
																	EEPROM_write(i,*a);
			data_init();
			regim=51;
			}
		if (SET) regim=51;
		return;
		}			
	
	if (regim==51){
		inc_dec_var(&u1grc,99);
		if (SET){
			EEPROM_write(u1grc_eeprom,u1grc);
			ukaz_na_param=0;
			regim=52;
			}
		return;
		}
	
	if (regim==52){
		inc_dec_var(&ukaz_na_param,4);// p  400
		if (ukaz_na_param>3) regim=0;
		if (SET)  regim=53;
		return;
		}
	if (regim==53){
		if (MINUS) if (u_measure_const[ukaz_na_param+4])  u_measure_const[ukaz_na_param+4]--;
		if (PLUS) {if (u_measure_const[ukaz_na_param+4]<1000) u_measure_const[ukaz_na_param+4]++; else u_measure_const[ukaz_na_param+4]=400;}
		if (SET){
			a=(unsigned char *)&u_measure_const[4];
			for (i=u_measure_const_eeprom; i<u_measure_const_eeprom+8 ; i++, a++)
																	EEPROM_write(i,*a);
				ukaz_na_param++;
				regim=52;
			}
		return;
		}
	//end********** ********************************************
}
//**************************************
void delay(unsigned char i){
 while(i) i--;
}
//**************************************
void numout(void){
//; di, sk=1, pause1(. ), sk=0 ,pause2- ,
	unsigned char i,b,num;
    for(i=0;i<10;i++)			//     10
    {
      	num=lcd_buffer[i];
		for(b=0;b<4;b++)
    	{
		 num<<=1;
    	 if  ( num&BIT(4) ) PORTLCD|=BIT(di); else PORTLCD&=~BIT(di);
		
    	 PORTLCD|=BIT(sk) ;//sk=1;
    	 delay(5);   //. 
    	 PORTLCD&=~BIT(sk);
    	 delay(5);// ,
    	}
    delay(10); //                1010-0	
    }
}

//**************************************
void result_in_bcd(int result)
{
unsigned char dig_out=0;
	
	bcd_num1=bcd_num2=bcd_num3=bcd_num4=0;
	
	if (result<0){
		time_flag|=BIT(flag_n_result);
		result*=-1;
		}
		else time_flag&=~BIT(flag_n_result);
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	if (dig_out==0) dig_out=0x0A;
	bcd_num1=dig_out;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	if (dig_out==0) dig_out=0x0A;
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	if (dig_out==0) dig_out=0x0A;
	bcd_num3=dig_out;
	if (result==0) result=0x0A;
	bcd_num4=result;
}
//**************************************
void load_3bcd_num_in_lcd(unsigned int *param, unsigned char ofset){
	result_in_bcd(*param);
	lcd_buffer[ofset]	=bcd_num2;
	lcd_buffer[ofset+1]	=bcd_num3;
	lcd_buffer[ofset+2]	=bcd_num4;
}
//**************************************
void load_2bcd_num_in_lcd(unsigned char *param, unsigned char ofset){
	result_in_bcd(*param);
	lcd_buffer[ofset]	=bcd_num3;
	lcd_buffer[ofset+1]	=bcd_num4;
}
void load_2bcd_num_int(signed int *param, unsigned char ofset){
	result_in_bcd(*param);
	lcd_buffer[ofset]	=bcd_num2;
	lcd_buffer[ofset+1]	=bcd_num3;
}

//**************************************
void view_state0_in_lcd(void){
	load_2bcd_num_int(&trezult[0],1);
	if (time_flag&BIT(flag_n_result)) lcd_buffer[0]=0x0f;
	
	load_2bcd_num_int(&trezult[1],4);
	if (time_flag&BIT(flag_n_result)) lcd_buffer[3]=0x0f;
	
	load_2bcd_num_int(&trezult[2],7);
	if (time_flag&BIT(flag_n_result)) lcd_buffer[6]=0x0f;
}
//**************************************
void view_state1_in_lcd(void){
unsigned char i;
	if ( time_flag&BIT(flag_view_1para) ){
		i=1;
		load_2bcd_num_int(&trezult[0],2);
		load_2bcd_num_int(&trezult[1],8);
		}
		else{
		i=3;
		load_2bcd_num_int(&trezult[2],2);
		load_2bcd_num_int(&trezult[3],8);
		}
	lcd_buffer[0]=i;// 
	lcd_buffer[1]=0x0f;//|_-
	lcd_buffer[6]=i+1;// 
	lcd_buffer[7]=0x0f;//|_-
}
//**************************************/
void view_state_25(unsigned char i){
	lcd_buffer[0]=view_state-1;
	load_2bcd_num_int(&trezult[i],2);
	lcd_buffer[4]=0x0D;
	lcd_buffer[5]=bcd_num4;
	if (time_flag&BIT(flag_n_result)) lcd_buffer[1]=0x0f;
	
	load_3bcd_num_in_lcd(&u_measure_const[i],7);
}

//**************************************
void cls_lcd_buffer(void){
unsigned char i;
 for(i=0;i<10;i++)
    lcd_buffer[i]=0x00;
}
//**************************************/
void blank_num2(unsigned char ofset){
	lcd_buffer[ofset]=0;
	lcd_buffer[ofset+1]=0;
}
//**************************************
void blank(void){
 if ( time_flag & BIT( flag_blank_param ) ){
	if (regim==20) {
		lcd_buffer[4]=0;
		return;
		}
	if ( (regim==30)||(regim==52) ) {
		lcd_buffer[0]=0;
		return;
		}
	if (regim==31)	{
		blank_num2(4);
		return;
		}
	if (regim==32)	{
		blank_num2(8);
		return;
		}
	if ( (regim==50)||(regim==55) ){
		blank_num2(6);
		return;
		}
	if (regim==51)	{
		blank_num2(1);
		return;
		}
	if (regim==53)	{ //1 000 000
		lcd_buffer[3]=0; //blank_num2(3);
		lcd_buffer[4]=0;//blank_num2(5);
		lcd_buffer[5]=0;
		return;
		}
	if ( (regim==41)||(regim==43) ) {
		lcd_buffer[ukaz_na_param+3]=0;
		return;
		}
	}
}
//**************************************/
void display (void){
unsigned int y;
unsigned char i,a;
	cls_lcd_buffer();
	
	if (regim==0){
		if (view_state==0)			view_state0_in_lcd();//   1,2,3-
		else if (view_state==1) 	view_state1_in_lcd();//   1,2  3,4 
		else if (view_state==2)	view_state_25(0);// ,   "",  .
		else if (view_state==3)	view_state_25(1);
		else if (view_state==4)	view_state_25(2);
		else 						view_state_25(3);

		return;
		}
	if (regim==20){
		lcd_buffer[3]=0x0C;
		if (!view_state) lcd_buffer[4]=0x0a; else lcd_buffer[4]=view_state;
		lcd_buffer[5]=0x0D;
		if (view_state>1) lcd_buffer[7]=view_state-1;
		return;
		}
	if ( (regim>29)&&(regim<33) ){
		i=ukaz_na_param;
		if (i&BIT(0)) i-=1;
		if (!i) lcd_buffer[0]=0x0e; else lcd_buffer[0]=i/2;
		load_2bcd_num_in_lcd(&parametr[i],4);
		lcd_buffer[6]=0x0c;
		lcd_buffer[7]=0x0f;
		load_2bcd_num_in_lcd(&parametr[i+1],8);
		return;
		}
	if ((regim>39)&&(regim<42)){// 
		lcd_buffer[1]=0x0E;
		for(i=0; i<5 ; i++){
			a=uprav_culer[i];
			if (a==0) a=0x0a;
			else if (a==1) a=0x0F;
			else if (a==2) a=0x01;
			lcd_buffer[i+3]=a;
			}
		return;
		}
	if ((regim>41)&&(regim<44)){// 
		lcd_buffer[0]=0x0B;
		lcd_buffer[1]=0x0E;
		for(i=0; i<5 ; i++){
			a=raskrutka_culer[i];
			if 	(a==0)	a=0x0F;
				else	a=0x01;
			lcd_buffer[i+3]=a;
			}
		return;
		}
	if (regim==50){
		lcd_buffer[2]=0x0a;
		lcd_buffer[3]=0x0b;
		load_2bcd_num_in_lcd(&t_ofset,6);
		return;
		}
	if (regim==51){
		load_2bcd_num_in_lcd(&u1grc,1);
		y=u1grc*shag_u;
		result_in_bcd(y);
		lcd_buffer[4]=bcd_num1;
		lcd_buffer[5]=bcd_num2;
		lcd_buffer[6]=bcd_num3;
		lcd_buffer[7]=0x0d;
		lcd_buffer[8]=bcd_num4;
		return;
		}
	if ( (regim>51)&&(regim<54) ){
		lcd_buffer[0]=ukaz_na_param+1;
		load_3bcd_num_in_lcd(&u_measure_const[ukaz_na_param+4],3);
		load_3bcd_num_in_lcd(&u_measure_const[ukaz_na_param],7);
		return;
		}
	if (regim==55){
		lcd_buffer[2]=0x0a; // 0F P
		lcd_buffer[3]=0x0b;
		lcd_buffer[7]=0x0e;
		return;
		}			
}
//*********************************************************
void display_direct(void){
	////61.0351Hz 0.016384sek  4meg //tcnt0=100 0.01sek
unsigned char i;

	skan_key();//.   flag_blank_param
	key_action();
		
	if ( --time_1sek==0 )//  1 
		{
		time_1sek=100;
		if (--time_in_regim==0) regim=0;//     

		if ( --time_state_switch==0 ){//  1,2  3,4 
				time_state_switch=4;
				time_flag^=BIT(flag_view_1para);
			}

		if ( !(time_flag&BIT(flag_satrt_end)) ){//   
			if ( --time_start==0 ) {
				for(i=uprav_culer_eeprom; i<uprav_culer_eeprom+5 ; i++)
					uprav_culer[i-uprav_culer_eeprom]=EEPROM_read(i);
				time_flag|=BIT(flag_satrt_end);
				}
			}
		}
	
	if ( --time_lcd==0 )
		{
		if (regim){//   
			time_lcd=10; //    0.1cek
			if ( --time_blank==0 ){
				//  . skan_key: time_flag&=~BIT(flag_blank_param); time_flag|=BIT(flag_num_out); time_blank=2;
				if ( time_flag & BIT( flag_blank_param ) ){//    
					time_blank=5; // ~0.5sek
					time_flag&=~BIT(flag_blank_param);// 
					time_flag|=BIT(flag_num_out);//     
					}
					else{//   
					time_blank=2; //  ~0.2sek
					time_flag|=BIT(flag_blank_param)|BIT(flag_num_out)|BIT(flag_adc);
					}
				}
			time_state_switch=4;//     view_state==1
			}
			else{//   // 
			time_lcd=30;//, ,    0,3cek
			time_blank=2;//   
			time_flag|=BIT(flag_blank_param)|BIT(flag_num_out)|BIT(flag_adc);
			}
			
		if ( time_flag&BIT(flag_num_out) ){
			display();
			blank();
			numout();
			time_flag&=~BIT(flag_num_out);
			}
		}
}
//*********************************************
void control_culer(void){
unsigned char i, a;

	for(i=0; i<5 ;i++){
		if (uprav_culer[i]==0)
			PORTCULER&=~pin_culer[i];//    
		else
		if (uprav_culer[i]==2)
			PORTCULER|=pin_culer[i];//    
		else{
			a=i;				// 480 >= 480  479 <= 470
			if (a>0) a-=1;		//   ,  2    (   )
			if 	( trezult[a] >= (unsigned int)(parametr[i*2+1]*10)  )		PORTCULER|=pin_culer[i]; //hi-param
			else if ( trezult[a] <= (unsigned int)(parametr[i*2]*10)  ) 	PORTCULER&=~pin_culer[i];//low-param
			// cul_0 trez[0]>parametr[1] trez[0]>parametr[0] i=0
			// cul_1 trez[0]>parametr[3] trez[0]>parametr[2] i=1
			// cul_2 trez[1]>parametr[5] trez[1]>parametr[4] 2
			// cul_3 trez[2]>parametr[7] trez[2]>parametr[6] 3
			// cul_4 trez[3]>parametr[9] trez[3]>parametr[8] 4
			}
		}
}

//*******************************************
void sleep_mk(void){
	ADCSRA&=~BIT(ADIE);
	MCUCR|= BIT(SE);
	asm("sleep");
	MCUCR=0;
	ADCSRA|=BIT(ADIE)|BIT(ADIF);//       ADC
}
//**************************************
int main (void) {

cli();
acd_init();
timer0_init();
port_init();
data_init();
uprav_culer[0]=2;//    -   
raskrutka_culer[0]=1;
sei();

	while(1){
		display_direct();
		receive_t();
		control_culer();
		sleep_mk();
		}
	
}


